    ;-----------------------------------------------;
    ; Nintendo e-Reader "Hello World" Example (Z80) ;
    ; (c) 2004 Tim Schuerewegen                     ;
    ;-----------------------------------------------;

    .area CODE (ABS)

    .include "erapi.asm"
    .include "shiftjis.asm"

    sys_input = 0xC2

    ;--------------;
    ; *** CODE *** ;
    ;--------------;

    .org 0x100

    ; ?
    ld  de, #0
    ld  hl, #0
    rst 8
    .db 0x21

    ; ERAPI_SetBackgroundMode()
    ; a = mode (0-2)
    xor a
    rst 0
    .db ERAPI_SetBackgroundMode

    ; ERAPI_SetBackgroundPalette()
    ; hl = pointer to palette data
    ; de = offset
    ; c  = number of colors
    ld  c, #0x02
    ld  de, #0x00
    ld  hl, #palette
    rst 0
    .db ERAPI_SetBackgroundPalette

    ; ERAPI_CreateRegion()
    ; h = bg# (0-3)
    ; l = palette bank (0-15)
    ; d = left
    ; e = top
    ; b = width
    ; c = height
    ld  bc, #0x1C03
    ld  de, #0x0101
    ld  hl, #0x0000
    rst 0
    .db ERAPI_CreateRegion
    ld  (handle_region), a

    ; ERAPI_SetTextColor()
    ; a = handle
    ; d = foreground color
    ; e = background color
    ld  de, #0x0100
    ld  a, (handle_region)
    rst 0
    .db ERAPI_SetTextColor

    ; ERAPI_DrawText()
    ; a  = handle
    ; bc = pointer to text
    ; d  = x
    ; e  = y
    ld  bc, #text
    ld  de, #0x5008
    ld  a, (handle_region)
    rst 0
    .db ERAPI_DrawText

    ; ERAPI_LoadBackgroundSystem()
    ; a = index (1-101)
    ; e = bg# (0-3)
    ld  a, #2
    ld  e, #3
    rst 0
    .db ERAPI_LoadBackgroundSystem

    ; ERAPI_FadeIn()
    ; a = number of frames
    xor a
    rst 0
    .db ERAPI_FadeIn

    ; ERAPI_SetBackgroundAutoScroll()
    ; a  = bg# (0-3)
    ; de = x
    ; bc = y
    ld  a, #3
    ld  bc, #0x0040
    ld  de, #0x0040
    rst 0
    .db ERAPI_SetBackgroundAutoScroll

main_loop:

    ; read & test key "b"
    ld  a, (sys_input)
    cp  #0x02
    jr  z, main_exit

    ; render frame
    ld  a, #1
    halt

    jr  main_loop

main_exit:

    ; ERAPI_Exit()
    ; a = return value (1=restart 2=exit)
    ld  a, #2
    rst 8
    .db ERAPI_Exit

    ;--------------;
    ; *** DATA *** ;
    ;--------------;

text:
;    .ascii 'hello world\0'
    .dw JIS_h, JIS_e, JIS_l, JIS_l, JIS_o, JIS_SP
    .dw JIS_w, JIS_o, JIS_r, JIS_l, JIS_d, 0

palette:
    ; 16 colors
    .dw 0x0000, 0xFFFF

    ;-------------------;
    ; *** VARIABLES *** ;
    ;-------------------;

handle_region:
    .ds 1
